PGSQL_CONTROL
-- $Id: aggregatex.m4,v 1.5 2006/03/08 01:30:03 babolo Exp $

CREATE AGGREGATE cat
     ( BASETYPE = text
     , SFUNC = textcat
     , STYPE = text
     , INITCOND = ''
     )
;
COMMENT ON AGGREGATE cat(text)           IS ' ';

CREATE OR REPLACE FUNCTION bool_and(bool, bool) RETURNS bool
 AS 'SELECT $1 AND $2
    '
 LANGUAGE SQL IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION bool_or(bool, bool) RETURNS bool
 AS 'SELECT $1 OR $2
    '
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION bool_and(bool, bool) IS '        ';
COMMENT ON FUNCTION bool_or(bool, bool)  IS '        ';

CREATE AGGREGATE conjunction
     ( BASETYPE = bool
     , SFUNC = bool_and
     , STYPE = bool
     , INITCOND = 1
     )
;
CREATE AGGREGATE disjunction
     ( BASETYPE = bool
     , SFUNC = bool_or
     , STYPE = bool
     , INITCOND = 0
     )
;
COMMENT ON AGGREGATE conjunction(bool)   IS ' AND  bool';
COMMENT ON AGGREGATE disjunction(bool)   IS ' OR  bool';

CREATE OR REPLACE FUNCTION varbitand(bit, bit) RETURNS varbit
 AS 'SELECT bitand( CASE WHEN d THEN $1 ELSE pg_catalog.bit($1, l, TRUE) END
                  , CASE WHEN d THEN pg_catalog.bit($2, l, TRUE) ELSE $2 END
                  )
      FROM (SELECT CASE WHEN d THEN bit_length($1) ELSE bit_length($2) END AS l, d
             FROM (SELECT CASE WHEN bit_length($1) > bit_length($2) THEN TRUE ELSE FALSE END AS d
           )i     )d
    '
 LANGUAGE SQL IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION varbitor(bit, bit) RETURNS varbit
 AS 'SELECT bitor( CASE WHEN d THEN $1 ELSE pg_catalog.bit($1, l, TRUE) END
                 , CASE WHEN d THEN pg_catalog.bit($2, l, TRUE) ELSE $2 END
                 )
      FROM (SELECT CASE WHEN d THEN bit_length($1) ELSE bit_length($2) END AS l, d
             FROM (SELECT CASE WHEN bit_length($1) > bit_length($2) THEN TRUE ELSE FALSE END AS d
           )i     )d
    '
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbitand(bit, bit)  IS 'AND      ';
COMMENT ON FUNCTION varbitor(bit, bit)   IS 'OR      ';

CREATE OR REPLACE FUNCTION varbitandN(bit, bit) RETURNS varbit
 AS 'SELECT CASE WHEN $1 IS NULL THEN $2 WHEN $2 IS NULL THEN $1 ELSE varbitand($1, $2) END
    '
 LANGUAGE SQL IMMUTABLE
;
CREATE OR REPLACE FUNCTION varbitorN(bit, bit) RETURNS varbit
 AS 'SELECT CASE WHEN $1 IS NULL THEN $2 WHEN $2 IS NULL THEN $1 ELSE varbitor($1, $2) END
    '
 LANGUAGE SQL IMMUTABLE
;
COMMENT ON FUNCTION varbitandN(bit, bit) IS 'varbitand  ';
COMMENT ON FUNCTION varbitorN(bit, bit)  IS 'varbitor  ';

CREATE AGGREGATE conjunction
     ( BASETYPE = bit
     , SFUNC = varbitandN
     , STYPE = varbit
     )
;

CREATE AGGREGATE disjunction
     ( BASETYPE = bit
     , SFUNC = varbitorN
     , STYPE = varbit
     )
;
COMMENT ON AGGREGATE conjunction(bit)    IS ' AND  bit';
COMMENT ON AGGREGATE disjunction(bit)    IS ' OR  bit';
